package com.jkcredit.invoice.credit.interserver;

import com.jkcredit.invoice.common.DataResult;

/**
 * 无车操作接口
 * @author mumuxigua
 */
public interface NoCarInterService {

    /**
     * 无车 车辆备案接口
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customerCarRec(String appKey, String api, String data, String requestid);

    /**
     * 无车 车辆备案查询接口
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customeRecUpperQuery(String appKey, String api, String data, String requestid);

    /**
     * 无车 实时运单开始指令
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult noCarBillStart(String appKey, String api, String data, String requestid);

    /**
     * 无车 实时运单结束指令
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult noCarBillEnd(String appKey, String api, String data, String requestid);

    /**
     * 无车 历史运单开始指令
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult noCarHisWaybillStart(String appKey, String api, String data, String requestid);

    /**
     * 无车 历史运单结束指令
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult noCarHisWaybillEnd(String appKey, String api, String data, String requestid);

    /**
     * 无车  运单号查询发票数据
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult noCarVoiceQuery(String appKey, String api, String data, String requestid);

    /**
     * 无车  获取未查询过发票的运单编号
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult noCarNoVoiceQuery(String appKey, String api, String data, String requestid);

    /**
     * 无车 账户余额查询接口
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult balanceQuery(String appKey, String api, String data, String requestid);

    /**
     * 无车红冲发票查询接口
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult redInkInvoiceQuery(String appKey, String api, String data, String requestid);

    /**
     * 无车  运单号查询发票数据 自己使用不对外
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult noCarVoiceOwnerQuery(String appKey, String api, String data, String requestid);
}
