package com.jkcredit.invoice.credit.interserver;

import com.jkcredit.invoice.common.DataResult;

/**
 * 自有车上游请求接口
 * @author mumuxigua
 */
public interface SelfCarInterService {

    /**
     * 自有车 用户卡列表查询接口；
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customeretcquery(String appKey, String api, String data, String requestid);

    /**
     * 自有车 卡信息查询接口
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customerQueryEtcInfo(String appKey, String api, String data, String requestid);

    /**
     * 自有车下发短信通知接口
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customeretcrec(String appKey, String api, String data, String requestid);

    /**
     * 自有车 卡绑定接口 渠道调用此接口，上传用户收到的短信验证码
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customeretcrecvalid(String appKey, String api, String data, String requestid);

    /**
     * 自有车 交易查询接口 渠道通过此接口可以查询单张卡连续90天内的交易（待开票、开票中、已开票）
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult getTradeList(String appKey, String api, String data, String requestid);

    /**
     * 自有车 申请开票接口 渠道通过此接口可以对该公司绑定的单张卡连续90天内的交易进行开票。
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult applInvoice(String appKey, String api, String data, String requestid);

    /**
     * 自有车 已开发票查询接口 渠道通过此接口可以根据该公司绑定的单张卡查询此卡在某个月开具的发票。
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult getSelfCarInvoicesByTime(String appKey, String api, String data, String requestid);

    /**
     * 自有车 已开发票查询接口 渠道通过此接口可以根据该公司的申请信息查询开票信息
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult getSelfCarInvoicesByAppl(String appKey, String api, String data, String requestid);

    /**
     * 自有车 发票下载 渠道通过此接口可以下载某公司某个月份开具的发票。
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult getSelfCarInvoicePackage(String appKey, String api, String data, String requestid);

    /**
     * 自有车 卡解绑接口。
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customerCarUnRec(String appKey, String api, String data, String requestid);

    /**
     * 自有车 卡换绑绑接口。
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customerCardChange(String appKey, String api, String data, String requestid);

    /**
     * 自有车 卡换绑绑查询接口。
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult customerCardChangeQuery(String appKey, String api, String data, String requestid);

    /**
     * 自有车 按交易查申请接口。
     * @param appKey
     * @param api
     * @param data
     * @param requestid
     * @return
     */
    DataResult tradeApplyQuery(String appKey, String api, String data, String requestid);
}
