package com.jkcredit.invoice.mapper.calculateinfor;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jkcredit.invoice.model.entity.calculate.NoCarCalculateInfor;
import com.jkcredit.invoice.model.vo.CompanyVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 计费信息维护接口
 * @author mumuxigua
 */
@Repository
public interface NoCarCalculateInforMapper extends BaseMapper<NoCarCalculateInfor> {

    /**
     * 分页查询 无车计费信息
     * @param page
     * @param calculateInfor
     * @return
     */
    IPage<List<NoCarCalculateInfor>> selectAllByPage(Page page, @Param("calculateInfor") NoCarCalculateInfor calculateInfor);

    /**
     * 插入无车 计费信息
     * @param record
     * @return
     */
    @Override
    int insert(NoCarCalculateInfor record);

    /**
     * 根据交易id查询无车 计费信息
     * @param tradeId
     * @return
     */
    NoCarCalculateInfor selectByTradeId(String tradeId);

    /**
     * 无车计费信息统计查询
     * @param record
     * @return
     */
    List<Map<String, String>> selectforStatis(@Param("calculateInfor") NoCarCalculateInfor record);

    /**
     * 根据企业信息 更新无车计费信息
     * @param companyVo
     * @return
     */
    int upDateCompany(CompanyVo companyVo);
}
