package com.jkcredit.invoice.mapper.customer;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jkcredit.invoice.model.entity.customer.CustomerOper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 无车运单导入接口
 * @author mumuxigua
 */
@Repository
public interface CustomerOperMapper extends BaseMapper<CustomerOper> {
    /**
     * 分页查询运单批次号信息
     * @param page
     * @param customerOper
     * @return
     */
    IPage<List<CustomerOper>> selectAllByPage(Page page, @Param("customerOper") CustomerOper customerOper);

    /**
     * 插入运单批次号信息
     * @param record
     * @return
     */
    @Override
    int insert(CustomerOper record);
}