package com.jkcredit.invoice.mapper.manager;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @description:
 * @author: sunzhaoning
 * @create: 2019-05-28 17:47
 * @version: V1.0
 **/
public interface ParamMapper extends BaseMapper<com.jkcredit.invoice.model.entity.manager.Param> {


    /**
     * 分页查询参数信息
     *
     * @param page  分页
     * @param param 查询参数
     * @return list
     */
    IPage<List<com.jkcredit.invoice.model.entity.manager.Param>> getParamsPage(Page page, @Param("query") com.jkcredit.invoice.model.entity.manager.Param param);


    /**
     * 通过参数名称查询参数信息
     *
     * @param paramName 参数名称
     * @return Param
     */
    com.jkcredit.invoice.model.entity.manager.Param getParamByParamName(String paramName);


    /**
     * 修改参数信息
     *
     * @param param
     * @return
     */
    Boolean updateParam(com.jkcredit.invoice.model.entity.manager.Param param);
}
