package com.jkcredit.invoice.mapper.waybill;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jkcredit.invoice.model.entity.waybill.NoCarWayBill;
import com.jkcredit.invoice.model.vo.CompanyVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 无车运单导入信息维护接口
 * @author mumuxigua
 */
@Repository
public interface NoCarWaybillImprtMapper extends BaseMapper<NoCarWayBill> {

    /**
     * 查询导入运单列表
     * @param page
     * @param noCarWayBill
     * @return
     */
    IPage<List<NoCarWayBill>> selectAllByPage(Page page, @Param("noCarWayBill") NoCarWayBill noCarWayBill);

    /**
     * 查询导入运单列表 导入失败的
     * @param page
     * @param noCarWayBill
     * @return
     */
    IPage<List<NoCarWayBill>> selectAllByPageException(Page page, @Param("noCarWayBill") NoCarWayBill noCarWayBill);

    /**
     * 插入导入运单列表
     * @param record
     * @return
     */
    int insertImport(NoCarWayBill record);

    /**
     * 更新导入运单列表
     * @param record
     * @return
     */
    int updateByPrimaryKey(NoCarWayBill record);

    /**
     * 根据运单号更新导入运单列表
     * @param record
     * @return
     */
    int updateByBillNum(NoCarWayBill record);

    /**
     * 根据运单好查询导入运单列表
     * @param wayBillNum
     * @return
     */
    NoCarWayBill selectByBillNum(String wayBillNum);

    /**
     * 查询导入运单列表
     * @param noCarWayBill
     * @return
     */
    List<NoCarWayBill> selectByHisFlagAndBillStatus(NoCarWayBill noCarWayBill);

    /**
     * 根据公司信息更新导入运单列表
     * @param companyVo
     * @return
     */
    int upDateCompany(CompanyVo companyVo);

    /**
     * 根据公司名称查询导入运单列表
     * @param customerName
     * @return
     */
    List<NoCarWayBill> getNoCarNoVoiceQuery(String customerName);
}
