package com.jkcredit.invoice.service.calculateinfor.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jkcredit.invoice.mapper.calculateinfor.SelfCarCalculateInforMapper;
import com.jkcredit.invoice.model.entity.calculate.SelfCarCalculateInfor;
import com.jkcredit.invoice.service.calculateinfor.SelfCarCalculateInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service

/**
 * @Description 自有车计费服务
 * @Author mashengyi
 * @Date 2022/2/8 18:28
 * @Param
 * @Return
 * @Exception
 *
 */
public class SelfcarCalculateInfoServiceImpl extends ServiceImpl<SelfCarCalculateInforMapper, SelfCarCalculateInfor> implements SelfCarCalculateInfoService {
    @Autowired
    SelfCarCalculateInforMapper carCalculateInforMapper;

    @Override
    public IPage<List<SelfCarCalculateInfor>> findByPageAndCalculateInfor(Page page, SelfCarCalculateInfor calculateInfor) {
        return carCalculateInforMapper.selectAllByPage(page, calculateInfor);
    }


    /**
     * 查询自有车计费统计信息
     *
     * @param calculateInfor
     * @return
     */
    @Override
    public List<Map<String, String>> findSelfcarCalculateInfoSta(SelfCarCalculateInfor calculateInfor) {
        //1.按企业统计出计费信息条数

        //2.按企业统计etc卡数量

        //3.通过计费的etc卡数查询对应的交易id数


        return carCalculateInforMapper.findSelfcarCalculateInfoSta(calculateInfor);
    }
}
