package com.jkcredit.invoice.service.manager;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.jkcredit.invoice.model.entity.manager.Param;
import com.jkcredit.invoice.util.RespR;


/**
 * @description:
 * @author: sunzhaoning
 * @create: 2019-05-28 17:49
 * @version: V1.0
 **/
public interface ParamService extends IService<Param> {

    /**
     * 分页查询用户信息（含有角色信息）
     *
     * @param page  分页对象
     * @param param 参数列表
     * @return
     */
    IPage getParamWithRolePage(Page page, Param param);


    /**
     * 通过参数名称查询参数信息
     *
     * @param paramName 参数名称
     * @return param
     */
    Param getParamsByParamName(String paramName);


    /**
     * 保存参数信息
     *
     * @param param DTO 对象
     * @return success/fail
     */
    Boolean saveParam(Param param);


    /**
     * 修改参数信息
     *
     * @param param
     * @return
     */
    RespR<Boolean> updateParam(Param param);


}
