package com.jkcredit.invoice.service.nocar;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jkcredit.invoice.model.entity.invoice.BillInvoice;
import com.jkcredit.invoice.util.RespR;

import java.util.List;
import java.util.Map;

/**
 * 无车发票服务
 * @author mumuxigua
 */
public interface NocarInvoiceService {
    /**
     * 查询所有发票接口
     *
     * @param page
     * @param billInvoice
     * @return
     */
    IPage<List<BillInvoice>> findByPageAndInvoice(Page page, BillInvoice billInvoice);

    /**
     * 查询无车发票统计数据库信息
     *
     * @param billInvoice
     * @return
     */
    Map<String, String> findInvoiceStatics(BillInvoice billInvoice);


    /**
     * 批量查询所有发票接口
     *
     * @param billInvoices
     * @return
     */
    RespR findImportNocarInvoices(List<BillInvoice> billInvoices);
}
